// CrossWorks for ARM - UCOSII thread finding script
//
// Copyright (c) 2005 Rowley Associates Limited.
//
// This file may be distributed under the terms of the License Agreement
// provided with this software.
//
// THIS FILE IS PROVIDED AS IS WITH NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

function getName(a)
{
  var s = "";
  for (i=0;i<a.length && a[i];i++)
    s += String.fromCharCode(a[i]);
  return s;
}

function getState(state)
{
  if (state == 0x00)
    return "ready";
  if (state == 0x1)
    return "semaphore wait";
  if (state == 0x2)
    return "mailbox wait";
  if (state == 0x4)
    return "queue wait";
  if (state == 0x8)
    return "suspended";
  if (state == 0x10)
    return "mutex wait";
  if (state == 0x20)
    return "event flag group wait";
  return "unknown";
}

function getregs(sp)
{
  var a = new Array();
  a[16] = Debug.evaluate("*(unsigned*)0x"+sp.toString(16)); 
  sp+=4;
  for (i=0;i<13;i++)
    {
      a[i] = Debug.evaluate("*(unsigned*)0x"+sp.toString(16)); 
      sp+=4;
    }
  a[14] = Debug.evaluate("*(unsigned*)0x"+sp.toString(16)); 
  sp+=4;
  a[15] = Debug.evaluate("*(unsigned*)0x"+sp.toString(16));
  sp+=4;
  a[13] = sp;
  return a;
}

function update() 
{
  Threads.clear();
  var x=Debug.evaluate("OSTCBCur");
  var current=x;
  if (x)
    {
      Threads.newqueue("Executing");
      x = Debug.evaluate("*(OS_TCB*)"+x);
      Threads.add(getName(x.OSTCBTaskName), x.OSTCBPrio, "executing", []);
    }
  x=Debug.evaluate("OSTCBList");
  if (x)
    Threads.newqueue("Waiting");
  var count=0;
  while (x && count<10)
    {
      var y = Debug.evaluate("*(OS_TCB*)"+x);         
      if (x!=current)
        Threads.add(getName(y.OSTCBTaskName), y.OSTCBPrio, getState(y.OSTCBStat), getregs(y.OSTCBStkPtr));
      x=y.OSTCBNext;
      count++;
    }
}
